#include <stdio.h>

static int IsBigEndian()
{
    union {
        unsigned char c[sizeof(int)];
	unsigned u;
    } x;
    x.u = 1;
    return x.c[0] == 0;
}


int main()
{
    printf("#ifndef CONFIG_H_INCLUDED\n");
    printf("#define CONFIG_H_INCLUDED\n");
    printf("#define MTX_CONFIG_BIG_ENDIAN %d\n",IsBigEndian());
    printf("#define MTX_CONFIG_LONG32 %d\n",sizeof(long) == 4);
    printf("#define MTX_CONFIG_LONG64 %d\n",sizeof(long) == 8);

    printf("#define MTX_CONFIG_STRING \"");
    if (sizeof(long) == 8) printf(" 64");
    if (sizeof(long) == 4) printf(" 32");
    if (IsBigEndian()) printf(" BIG_ENDIAN");
    printf("\"\n");
    printf("#endif\n");
    return 0;
}

